#include <cstdio>

class A
{
public:
  //A() = delete;
  A()
  { printf("ctor A() called for %p\n", this); }
  ~A() { printf("dtor ~A() of %p\n", this); }

  A(A const &o) : value(o.value)
  {
    printf("ctor A(A.. value=%d) called for %p\n", o.value, this);
  }

  A &operator = (A const &o)
  {
    value = o.value;
    printf("copy assign value=%d to %p\n", value, this);
    return *this;
  }
  

  explicit A(int x) : value(x)
  { printf("ctor A(%d) called for %p\n", x, this); }

  int value = 0;

};

//A global_a;

int main()
{
  printf("Hello world\n");

  A local_a1 ( 10);
  A local_a = local_a1;
  local_a1 = local_a = A(99);
  //printf("global_a.value=%d\n", global_a.value);
  printf("local_a.value=%d\n", local_a.value);

  printf("allocate on the heap\n");

  A *heap_a = new A;
  printf("heap_a->value=%d\n", heap_a->value);
  heap_a->value = 22;

  printf("now we delete heap_a: %p\n", heap_a);
  delete heap_a;

  A *heap_a2 = new A;
  printf("heap_a2->value=%d\n", heap_a2->value);
  delete heap_a2;

 return 0;
}
