#include <cstdio>


class A
{
public:
  int x = 4;

  virtual int get_x() const
  {
    printf("A::get_x()...\n");
    return x;
  }
  
  virtual ~A() = default; //{ printf("~A()\n"); }
};


class B : public A
{
public:
  unsigned u;

  int get_x() const override
  {
    printf("B::get_x()...\n");
    return 2 * x;
  }

  //~B() { printf("~B()\n"); }
};

int main()
{
  printf("sizeof(A) = %zd\n", sizeof(A));
  printf("sizeof(B) = %zd\n", sizeof(B));

  A *a = new A;

  a->get_x();
#if 1
  B *b = dynamic_cast<B*>(a);
  if (b != nullptr)
    b->u = 10;
  else
    printf("TYPE ERROR\n");
#endif

  delete a;
  return 0;
}
